/* 
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Simon Hofmann
   co-programmer:
*/

#include "sound_test.h"

static Mix_Music* music = NULL;

using namespace std;

void handleKey(SDL_KeyboardEvent key);

SoundControl* sound = NULL;
int sfx_channel1 = -1;
int sfx_channel2 = -1;
int finished = 0;

SoundTest::SoundTest() {
  sound = SoundControl::getInstance();
}

SoundTest::~SoundTest() {
  sound->deleteInstance();
}

int main( int argc, char* argv[] ) {
  SoundTest();
  SDL_Surface *screen;
  SDL_Event event;
  SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO); 
  screen = SDL_SetVideoMode(320, 240, 0, 0);
  while(!finished) {
    while(SDL_PollEvent(&event)) {
      switch(event.type) {
      case SDL_QUIT:
	finished = 1;
	break;
      case SDL_KEYDOWN:
      case SDL_KEYUP:
	handleKey(event.key);
	break;
      }
    }
    SDL_Delay(50);
  }
  SDL_Quit();
}

void handleKey(SDL_KeyboardEvent key) {
  switch(key.keysym.sym) {
  case SDLK_a:
    if(key.type == SDL_KEYDOWN) {
      if(sfx_channel1 < 0) {
	sfx_channel1 = sound->playWav("sound1.wav");
      }
    } else {
      Mix_HaltChannel(sfx_channel1);
      sfx_channel1 = -1;
    }
    break;
  case SDLK_s:
    if(key.type == SDL_KEYDOWN) {
      if(sfx_channel2 < 0) {
	sfx_channel2 = sound->playWav("sound2.wav");
      }
    } else {
      Mix_HaltChannel(sfx_channel2);
      sfx_channel2 = -1;
    }
    break;
  case SDLK_m:
    if(key.state == SDL_PRESSED) {
      if(music == NULL) { 
	sound->playOgg("music.ogg");
      } else {
	Mix_HaltMusic();
	Mix_FreeMusic(music);
	music = NULL;
      }
    }
    break;
  case SDLK_q:
    finished = 1;
    break;
  }
}
